<?php
/*
  $Id: colissimo.php,v 1.1 2003/10/16 21:11:22 webot Exp $

  The Exchange Project - Community Made Shopping!
  http://www.theexchangeproject.org

  Copyright (c) 2000,2001 The Exchange Project

  Released under the GNU General Public License

    adaptation Stphane GUIBOUD-RIBAUD <devteam@e-network.fr>
	           xaglo <xaglo@free.fr>
			   
	mise a jour v1.4.2 by fram 2003/05/10		   

www.oscommerce-fr.info
*/


  class colissimo {
    var $code, $title, $description, $icon, $enabled;

// class constructor
    function colissimo() {
      $this->code = 'colissimo';
      $this->title = MODULE_SHIPPING_COLISSIMO_TEXT_TITLE;
      $this->description = MODULE_SHIPPING_COLISSIMO_TEXT_DESCRIPTION;
	  $this->sort_order = MODULE_SHIPPING_COLISSIMO_SORT_ORDER;
      $this->icon = DIR_WS_ICONS . 'colissimo.gif'; // ou shipping_laposte.gif au choix
	  $this->tax_class = MODULE_SHIPPING_COLISSIMO_TAX_CLASS;
      $this->enabled = MODULE_SHIPPING_COLISSIMO_STATUS;
    }

// class methods
    function quote($method = '') {
      global $order, $cart, $shipping_weight;

      $this->quotes = array('id' => $this->code,
                            'module' => MODULE_SHIPPING_COLISSIMO_TEXT_TITLE,
                            'methods' => array());

      if (tep_not_null($this->icon))
	$this->quotes['icon'] = tep_image($this->icon, $this->title);

      $dest_country = $order->delivery['country']['iso_code_2'];

      if (($dest_country != 'FR') && ($dest_country != 'FX')) {
	$this->quotes['error'] = MODULE_SHIPPING_COLISSIMO_INVALID_ZONE;
	return $this->quotes;
      }

      if (substr($order->delivery['postcode'], 0, 2) == substr(MODULE_SHIPPING_COLISSIMO_STORE_POSTCODE, 0, 2)) {
	$cost = constant('MODULE_SHIPPING_COLISSIMO_INTRA');
      } else {
	$cost = constant('MODULE_SHIPPING_COLISSIMO_EXTRA');
      }

      $table = split("[:,]" , $cost);
      for ($i = 0; $i < sizeof($table); $i+=2) {
	if ($shipping_weight > $table[$i])
	  continue;

	$this->quotes['methods'][] = array('id'    => $this->code,
					   'title' => $shipping_weight . ' ' . MODULE_SHIPPING_COLISSIMO_TEXT_UNITS,
					   'cost'  => $table[$i+1] + MODULE_SHIPPING_COLISSIMO_HANDLING);
	
      if ($this->tax_class > 0) {
        $this->quotes['tax'] = tep_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);
      }
    return $this->quotes;
      }

      $this->quotes['error'] = MODULE_SHIPPING_COLISSIMO_TOO_HEAVY;
      return $this->quotes;
    }

    function check() {
      $check = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_SHIPPING_COLISSIMO_STATUS'");
      $check = tep_db_num_rows($check);

      return $check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Valider Colissimo', 'MODULE_SHIPPING_COLISSIMO_STATUS', 'True', 'Activer / Dsactiver Colissimo sans perdre les valeurs changes', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Colissimo intradpartement', 'MODULE_SHIPPING_COLISSIMO_INTRA', '0.500:4.00, 1:4.80, 2:5.10, 3:6.00, 5:7.00, 7:8.00, 10:10.00, 15:11.40, 30:16.00', 'Port bas sur le poids total des produits, tarif intradpartemental. Exemple: 1:3.50,2:5.50,etc.. Jusqu\' 1 Kg factur 3.50, jusqu\' 2 Kg, 5.50, etc', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Colissimo extradpartement', 'MODULE_SHIPPING_COLISSIMO_EXTRA', '0.500:4.80, 1:6.00, 2:6.50, 3:7.20, 5:8.30, 7:9.30, 10:11.20, 15:12.50, 30:17.10', 'Port bas sur le poids total des produits, tarif extradpartemental. Exemple: 1:4.50, 2:6.50, etc. Jusqu\' 1 Kg factur 4.50, jusqu\' 2 Kg , 6.50, etc', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Frais fixes', 'MODULE_SHIPPING_COLISSIMO_HANDLING', '0', 'Frais fixes (emballage) pour colissimo', '6', '0', now())");
	  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Classe de taxe', 'MODULE_SHIPPING_COLISSIMO_TAX_CLASS', '2', 'Appliquer le taux de taxe suivant sur les frais de livraison.', '6', '0', 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Code postal', 'MODULE_SHIPPING_COLISSIMO_STORE_POSTCODE', '06300', 'Code postal de la boutique', '6', '0', now())");
	  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Ordre de tri', 'MODULE_SHIPPING_COLISSIMO_SORT_ORDER', '0', 'Ordre de tri pour l\'affichage (Le plus petit nombre est montr en premier).', '6', '0', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_SHIPPING_COLISSIMO_STATUS', 'MODULE_SHIPPING_COLISSIMO_INTRA', 'MODULE_SHIPPING_COLISSIMO_EXTRA', 'MODULE_SHIPPING_COLISSIMO_HANDLING', 'MODULE_SHIPPING_COLISSIMO_STORE_POSTCODE', 'MODULE_SHIPPING_COLISSIMO_TAX_CLASS','MODULE_SHIPPING_COLISSIMO_SORT_ORDER');
    }
  }
?>
