<?php
/*
  wallie.php,v 1.00 2003/11/19 16:00:00
  Author Ivan Pavlov, ip@thehyper.net

  contribution for osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 Wallie B.V.

  Released under the GNU General Public License
  
*/

  class wallie {
    var $code, $title, $description, $enabled;

// class constructor
    function wallie() {
    	global $customer_id, $HTTP_GET_VARS; 
      $this->code = 'wallie';
      $this->title = MODULE_PAYMENT_WALLIE_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_WALLIE_TEXT_DESCRIPTION;
      $this->enabled = (MODULE_PAYMENT_WALLIE_STATUS == 'True') ;

      $this->id = $customer_id . time();
	    $this->exists = false;
      $this->data=array();
      $this->form_action_url = 'https://betaal-met.wallie-card.nl/';
      
	    if(isset($HTTP_GET_VARS['ShoppingCartID'])){
	      $saved_qry = tep_db_query("SELECT * FROM wallie_payments WHERE ShoppingCartID='$HTTP_GET_VARS[ShoppingCartID]' AND customer_id = '$customer_id'");
	      if(tep_db_num_rows($saved_qry) > 0){
	      	$saved = tep_db_fetch_array($saved_qry);
	      	$this->id = $saved['ShoppingCartID'];
	      	$this->data = $saved;
	      	$this->exists = true;
	      }
	    }
    }
    

// class methods
    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
    	global $HTTP_SESSION_VARS, $customer_id,$currencies, $order;
    	$db_array = array(
    		'ShoppingCartID'=>$this->id,
    		'customer_id' => $customer_id,
    		'expected_amount'=> 100* round($order->info['total'] * $currencies->get_value('EUR'), 2),
    		'created_time'=>'now()',
    		'session' => addslashes(session_encode()) //for debugging, fault tracing or future enhancements
    	);
    	tep_db_perform('wallie_payments', $db_array);
      return array("title"=>$this->title,'fields'=> array(array('title'=>MODULE_PAYMENT_WALLIE_ID, 'field'=>$this->id)));
    }

    function process_button() {
      global $order, $currencies;

       $process_button_string = MODULE_PAYMENT_WALLIE_ALERT . tep_draw_hidden_field('MerchantID', MODULE_PAYMENT_WALLIE_MERCHANT_ID) .
                               tep_draw_hidden_field('ShoppingCartID', $this->id) .
                               tep_draw_hidden_field('Amount', 100* round($order->info['total'] * $currencies->get_value('EUR'), 2));

      return $process_button_string;
    }

    function before_process() {
    	global $order;
    	if(!$this->exists || $this->data['ResultCode'] != 200) tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));
    	else {
    		$order->info['comments'] .= MODULE_PAYMENT_WALLIE_ID.": ".$this->id ;
    		$this->email_footer = MODULE_PAYMENT_WALLIE_ID .': ' . $this->id;
    	}
      return false;
    }

    function after_process() {
    	global $insert_id;
    	tep_db_query("UPDATE wallie_payments SET processed = 'Y', processed_time=now(), order_id = '$insert_id', session='' WHERE ShoppingCartID = '{$this->id}'");
    	return false;
    }

    function output_error() {
      return false;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_WALLIE_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
    	$create_table_qry_str = 
    		"CREATE TABLE IF NOT EXISTS `wallie_payments` (
				  `ShoppingCartID` varchar(45) NOT NULL default '',
				  `ResultCode` int(11) NOT NULL default '0',
				  `TransDate` date default NULL,
				  `TransTime` time default NULL,
				  `TestMode` int(11) NOT NULL default '0',
				  `TransferAmount` int(11) NOT NULL default '0',
				  `TransactionCosts` int(11) NOT NULL default '0',
				  `TotalAmount` int(11) NOT NULL default '0',
				  `customer_id` int(11) default NULL,
    			`expected_amount` int(11) NOT NULL default '0',
				  `processed` char(1) default 'N',
    		  `created_time` datetime default NULL,
				  `processed_time` datetime default NULL,
    			`order_id` int(11) default NULL,
				  `session` text,
				  PRIMARY KEY  (`ShoppingCartID`)
				) TYPE=MyISAM";
    	tep_db_query($create_table_qry_str);
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Inschakelen Wallie Module', 'MODULE_PAYMENT_WALLIE_STATUS', 'True', 'Wilt u Wallie-card betalingen accepteren?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant ID', 'MODULE_PAYMENT_WALLIE_MERCHANT_ID', '123456', 'Het merchant ID voor het Wallie betalingsysteem', '6', '2', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Wachtwoord', 'MODULE_PAYMENT_WALLIE_MERCHANT_PWD', '123456', 'Het merchant wachtwoord voor het Wallie betalingsysteem', '6', '3', now())");
      //enable following line for OSCommerrce v 2.2
      //tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Instellen Order Status', 'MODULE_PAYMENT_WALLIE_ORDER_STATUS', '0', 'Stel de status van de orders met deze betaalmodule in op deze waarde', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array(
      	'MODULE_PAYMENT_WALLIE_STATUS',
      	'MODULE_PAYMENT_WALLIE_MERCHANT_ID',
      	'MODULE_PAYMENT_WALLIE_MERCHANT_PWD'
      	//enable following line for OSCommerrce v 2.2
      	//,'MODULE_PAYMENT_WALLIE_ORDER_STATUS'
      );
    }
    
}
?>
